/*
	Copyright (c) 2001 Maurice Gittens <maurce@gittens.nl>

   This software is distributed under the GNU General
   Public License.
	See the file COPYING for more information on usage and
	redistribution of this file and for a DISCLAIMER OF ALL
	WARRANTIES.

	Written by Maurice Gittens <maurice@gittens.nl>.
*/

#ifndef TINY_GENERICSYMBOL_H
#define TINY_GENERICSYMBOL_H

#include <tiny_rewritablesymbol.h>

class tiny_genericSymbol : public tiny_rewritableSymbol  {
public: 
	tiny_genericSymbol(Type t,
	                      const std::string& n,
	                      unsigned int i,
	                      unsigned ln)
	: tiny_rewritableSymbol(t,n,i,ln)
	{
	}

	void addArgument(const std::string& arg)
	{
      args.push_back(arg);	
	}

	virtual unsigned int getEncodedId() const { return makeGeneric(getId()); }
		
	~tiny_genericSymbol() {}

	void setAction(const tiny_action& act) { action = &act; }
	const tiny_action& getAction() const { return *action; }
	
private:
   std::vector<std::string> args;
   const tiny_action* action;
};

#endif
